## tarantool 1.4.5+20120503

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(tarantool)

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(CheckCXXSourceRuns)
include(TestBigEndian)
include(CheckFunctionExists)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(JING jing)
find_program(LYNX lynx)
find_program(CAT cat)
find_program(GIT git)
find_program(RAGEL ragel)
find_program(CONFETTI confetti)
find_program(LD ld)
find_program(POD2MAN pod2man)

include(cmake/check_objective_c_compiler.cmake)
include(cmake/luajit.cmake)

#
# This instructs the rest of the build system what product
# and what modules to produce.
#
set (TARANTOOL_PRODUCT "box")
set (TARANTOOL_MODULES "box")
set (TARANTOOL_CLIENTS "")

#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
if (GCC_VERSION VERSION_GREATER 4.4 OR GCC_VERSION VERSION_EQUAL 4.4)
        message(STATUS "GCC Version >= 4.4")
else()
    message (FATAL_ERROR "GCC version should be >= 4.4")
endif()

#
# Perform operating-system specific configuration.
#
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(TARGET_OS_LINUX 1)
#
# Enable GNU glibc extentions.
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
#
# On 32-bit systems, support files larger than 2GB
# (see man page for feature_test_macros).
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD")
    set(TARGET_OS_FREEBSD 1)
    set(TARGET_OS_DEBIAN_FREEBSD 1)
# Enable GNU glibc extentions.
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
#
# On 32-bit systems, support files larger than 2GB
# (see man page for feature_test_macros).
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    set(TARGET_OS_FREEBSD 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    set(TARGET_OS_DARWIN 1)
else()
    message (FATAL_ERROR "Unsupported platform -- ${CMAKE_SYSTEM_NAME}")
endif()

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
check_include_file(sys/time.h HAVE_SYS_TIME_H)

check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
check_function_exists(fdatasync HAVE_FDATASYNC)
check_function_exists(memmem HAVE_MEMMEM)
check_function_exists(memrchr HAVE_MEMRCHR)

test_big_endian(HAVE_BYTE_ORDER_BIG_ENDIAN)

#
# We do not perform host-to-network byte order translation,
# and simply assume the machine is little-endian.
# We also do not bother with trying to avoid unaligned
# word access. Refuse to compile on rare hardware such as
# Sparc or Itanium.
#
if (${HAVE_BYTE_ORDER_BIG_ENDIAN} OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sparc" OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ia64" OR
    ${CMAKE_SYSTEM_PROCESSOR} MATCHES "^alpha")
    message (FATAL_ERROR "Unsupported architecture -- ${CMAKE_SYSTEM_PROCESSOR}, ")
    message (FATAL_ERROR "Tarantool currently only supports little-endian hardware")
    message (FATAL_ERROR "with unaligned word access.")
endif()

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

#
# Tarantool uses 'coro' (coroutines) library # to implement
# cooperative multi-tasking. Since coro.h is included
# universally, define the underlying implementation switch
# in the top level CMakeLists.txt, to ensure a consistent
# header file layout across the entire project.
#
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "amd64")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCORO_ASM")
else()
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCORO_SJLJ")
endif()
#
# Perform build type specific configuration.
#
set (CMAKE_C_FLAGS_DEBUG "-ggdb -O0 -fexceptions -funwind-tables")
set (CMAKE_C_FLAGS_RELWITHDEBUGINFO "-ggdb -O2 -fexceptions -funwind-tables -DNDEBUG -DNVALGRIND")
set (CMAKE_C_FLAGS_RELEASE "-DNDEBUG -DNVALGRIND")

#
# Enable 'make TAGS' target.
#
add_custom_target(TAGS COMMAND ctags -R --langmap=ObjectiveC:.m -e -f TAGS
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#
# Define TARANTOOL_VERSION -- a string constant with tarantool version.
#
set (TARANTOOL_VERSION "")
execute_process (COMMAND ${GIT} describe HEAD
    OUTPUT_VARIABLE TARANTOOL_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
#
# Make sure the version is set even if building
# out of source.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "4")
set (CPACK_PACKAGE_VERSION_PATCH "5")
if (TARANTOOL_VERSION STREQUAL "")
    set (TARANTOOL_VERSION
        "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif()

#
# Set flags for all include files: those maintained by us and
# coming from third parties.
# We must set -fno-omit-frame-pointer here, since we rely
# on frame pointer when getting a backtrace, and it must
# be used consistently across all object files.
# The same reasoning applies to -fno-stack-protector switch.
#
set (CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -fno-omit-frame-pointer -fno-stack-protector -fexceptions -funwind-tables")
#
# Tarantool code is written in GNU C dialect.
# Additionally, compile it with more strict flags than the rest
# of the code.
#
if (${CMAKE_BUILD_TYPE} STREQUAL "None")
    set (core_cflags "-std=gnu99")
else()
    set (core_cflags "-std=gnu99 -Wall -Wextra")
    set (core_cflags "${core_cflags} -Wno-sign-compare -Wno-strict-aliasing")
endif()

# Only add -Werror if it's a debug build, done by developers.
# Community builds should not cause extra trouble.

if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set (core_cflags "${core_cflags} -Werror")
else()
# Remove VALGRIND code and assertions in *any* type of release build.
    set (core_cflags "${core_cflags} -DNDEBUG -DNVALGRIND")
endif()

#
# Specify where to look for include files.
#
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_BINARY_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/connector/c/include")

#
# Specify prefixes
#
if (NOT DEFINED CMAKE_SYSCONF_DIR)
    set (CMAKE_SYSCONF_DIR "etc")
endif()
if (NOT DEFINED CMAKE_LOCALSTATE_DIR)
    set (CMAKE_LOCALSTATE_DIR "var")
endif()
if (NOT DEFINED CMAKE_MAN_DIR)
    set (CMAKE_MAN_DIR "man")
endif()

#
# Now handle all configuration options.
#
option(ENABLE_DOC "Enable building of documentation" OFF)

# LuaJIT options are defined in cmake/luajit.cmake

option(ENABLE_CLIENT "Enable building of console client" OFF)
if (ENABLE_CLIENT)
    set (TARANTOOL_CLIENTS ${TARANTOOL_CLIENTS} "tarantool")
endif()

option(ENABLE_GCOV "Enable integration with gcov, a code coverage program" OFF)
if (ENABLE_GCOV)
    check_library_exists (gcov __gcov_flush  ""  HAVE_GCOV)
    if (NOT HAVE_GCOV)
        message (FATAL_ERROR
                 "ENABLE_GCOV option requested but gcov library is not found")
    endif()
    set (GCOV_C_FLAGS "-fprofile-arcs -ftest-coverage")
    set (GCOV_LDFLAGS "-fprofile-arcs -ftest-coverage")
endif()

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC} OR
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86|amd64"))
        # We only know this option to work with gcc
        # on x86 architecture.
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
    # Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    check_include_file(bfd.h HAVE_BFD_H)
    if (HAVE_BFD_LIB AND HAVE_BFD_H)
        set (HAVE_BFD True)
    endif()
endif()

option(ENABLE_STATIC "Perform static linking whenever possible." OFF)
if (ENABLE_STATIC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static")
endif()

# CMake believes that Objective C is a flavor of C++, not C,
# and uses g++ compiler for .m files. Since talking CMake out
# of this idea is difficult, and since gcc or g++ are only
# front-ends to the language-specific compiler specified in
# -x option, simply use CXX flags to build Objective C files.
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS}")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fexceptions -fobjc-exceptions")

# Use GNU Objective C runtime on Mac OS X
if (TARGET_OS_DARWIN)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fgnu-runtime")
endif()

add_subdirectory(third_party)
add_subdirectory(cfg)
add_subdirectory(connector)
add_subdirectory(src)
add_subdirectory(extra)
add_subdirectory(mod)
add_subdirectory(client)
add_subdirectory(test)
add_subdirectory(doc)

install (FILES README LICENSE doc/box-protocol.txt
         DESTINATION share/doc/tarantool)

include (cmake/tarantool_cpack.cmake)

# tarantool info summary (used in server version output)
#
set(TARANTOOL_OPTIONS "-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_STATIC=${ENABLE_STATIC} -DENABLE_GCOV=${ENABLE_GCOV}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_TRACE=${ENABLE_TRACE} -DENABLE_BACKTRACE=${ENABLE_BACKTRACE}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_CLIENT=${ENABLE_CLIENT}")

set(TARANTOOL_BUILD "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_BUILD_TYPE}")

#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/include/config.h.cmake"
    "${PROJECT_BINARY_DIR}/include/config.h"
    )
configure_file(
    "${PROJECT_SOURCE_DIR}/doc/tnt.ent.cmake"
    "${PROJECT_BINARY_DIR}/doc/tnt.ent"
    )

configure_file(
    "${PROJECT_SOURCE_DIR}/doc/www-data.in/download.cmake"
    "${PROJECT_BINARY_DIR}/doc/www-data.in/download"
    )
message (STATUS "")
message (STATUS "Tarantool configuration is complete:")
message (STATUS "")
message (STATUS "VERSION: ${TARANTOOL_VERSION}")
message (STATUS "BUILD: ${TARANTOOL_BUILD}")
message (STATUS "CFLAGS:${CMAKE_C_FLAGS} ${core_cflags}")
message (STATUS "PREFIX: ${CMAKE_INSTALL_PREFIX}")
message (STATUS "MODULES: ${TARANTOOL_MODULES}")
message (STATUS "ENABLE_STATIC: ${ENABLE_STATIC}")
message (STATUS "ENABLE_GCOV: ${ENABLE_GCOV}")
message (STATUS "ENABLE_TRACE: ${ENABLE_TRACE}")
message (STATUS "ENABLE_BACKTRACE: ${ENABLE_BACKTRACE} (symbol resolve: ${HAVE_BFD})")
message (STATUS "ENABLE_CLIENT: ${ENABLE_CLIENT}")
message (STATUS "ENABLE_BUNDLED_LUAJIT: ${ENABLE_BUNDLED_LUAJIT}")
message (STATUS "ENABLE_DOC: ${ENABLE_DOC}")
message (STATUS "")
message (STATUS "To view or modify configuration results, check out CMakeCache.txt.")
message (STATUS "")

=== client/CMakeLists.txt ===

# function to build tarantool clients that use connector/c
# 
function(tarantool_client client_name)
	set (client_sources ${ARGV})
	list(REMOVE_ITEM client_sources ${client_name})
	add_executable(${client_name} ${client_sources}
		       ${CMAKE_SOURCE_DIR}/src/errcode.c)
	set (client_libs tntnet tntsql tnt)
	set_target_properties(${client_name} PROPERTIES COMPILE_FLAGS "${core_cflags}")
	target_link_libraries (${client_name} ${client_libs})
endfunction()

foreach (client ${TARANTOOL_CLIENTS})
	add_subdirectory(${client})
endforeach()

=== extra/CMakeLists.txt ===

# scripts for RPM package
#
if ("${CPACK_GENERATOR}" STREQUAL "RPM")
        # chmod +x 655
	install (FILES tarantool_box DESTINATION /etc/rc.d/init.d
		 PERMISSIONS
		 OWNER_READ OWNER_WRITE
		 GROUP_READ GROUP_EXECUTE
		 WORLD_READ WORLD_EXECUTE)
        # chmod +x 755
        install (FILES tarantool_multi.sh DESTINATION bin
                 PERMISSIONS
                 OWNER_READ OWNER_WRITE OWNER_EXECUTE
                 GROUP_READ GROUP_EXECUTE
                 WORLD_READ WORLD_EXECUTE)
        # chmod +x 755
        install (FILES tarantool_expand.sh DESTINATION bin
                 PERMISSIONS
                 OWNER_READ OWNER_WRITE OWNER_EXECUTE
		 GROUP_READ GROUP_EXECUTE
		 WORLD_READ WORLD_EXECUTE)
endif()

ADD_EXECUTABLE(txt2c txt2c.c)

=== mod/CMakeLists.txt ===

function(tarantool_module mod)
  set (module_sources ${ARGV})
  list(REMOVE_ITEM module_sources ${mod})
  set_source_files_properties(
      ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
      PROPERTIES COMPILE_FLAGS "-Wno-unused" GENERATED True)
  add_executable(tarantool_${mod}
      ${module_sources}
      ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)

  add_library(lt${mod} STATIC ${recompiled_sources})
  set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
    "${core_cflags} ${GCOV_C_FLAGS} -DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
  add_dependencies(lt${mod} generate_headers generate_admin_m)

  target_link_libraries(tarantool_${mod} lt${mod} ${GCOV_LDFLAGS} ${common_libraries})
  set_target_properties(tarantool_${mod} PROPERTIES COMPILE_FLAGS
      "${core_cflags} ${GCOV_C_FLAGS}")

  if (ENABLE_STATIC)
      set_target_properties(tarantool_${mod} PROPERTIES
          LINK_SEARCH_END_STATIC ON)
  endif()

  install (TARGETS tarantool_${mod} DESTINATION bin)

endfunction()

foreach (module ${TARANTOOL_MODULES})
  add_subdirectory(${module})
endforeach()

=== src/CMakeLists.txt ===
#
# libev library
#
add_library(ev tarantool_ev.c)

check_c_compiler_flag ("-Wno-unused-result" gcc_has_wno_unused_result)
check_c_compiler_flag ("-msse4" gcc_has_sse4)
check_include_file("cpuid.h" gcc_has_cpuid)

if (NOT gcc_has_sse4)
    message (FATAL_ERROR "GCC must support SSE4 instructions (-msse4).")
endif()

if (NOT gcc_has_cpuid)
    message (FATAL_ERROR "GCC is missing cpuid.h")
endif()

if (gcc_has_wno_unused_result)
    set_source_files_properties(tarantool_ev.c
        PROPERTIES COMPILE_FLAGS "-Wno-unused-result")
endif()

if (TARGET_OS_LINUX)
#
# Enable Linux-specific event notification API (man inotify)
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_INOTIFY")
elseif (TARGET_OS_FREEBSD)
#
# On FreeBSD build libev loop on top of
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_KQUEUE")
endif()
#
# libev uses ceil and floor from the standard math library
#
target_link_libraries(ev m)

#
# Build admin.m from admin.rl, but only if admin.rl was changed.
# The same applies to memcached.m/memcached.rl.
# We track admin.m and memcached.m in revision control, and thus do not
# require engineers who do not modify .rl files to have Ragel
# installed.
#
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/admin.m
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/admin.rl -o src/admin.m
    DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.rl)

add_custom_target(generate_admin_m DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.m)
# do not randomly try to re-generate admin.m after a fresh checkout
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/src/admin.m)

#
# Do not clean admin.m, memcached.m or other
# generated files in 'make clean' -- they are under
# revision control.
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)

set_source_files_properties(cpu_feature.m
    PROPERTIES COMPILE_FLAGS "-msse3 -msse4")

#
# Used by modules.
#
set (recompiled_sources
     ${CMAKE_SOURCE_DIR}/src/tarantool.m
     ${CMAKE_SOURCE_DIR}/src/tarantool_lua.m
     ${CMAKE_SOURCE_DIR}/src/say.m
     ${CMAKE_SOURCE_DIR}/src/assoc.m
     ${CMAKE_SOURCE_DIR}/src/admin.m
     ${CMAKE_SOURCE_DIR}/src/replication.m
     ${CMAKE_SOURCE_DIR}/src/fiber.m PARENT_SCOPE)

set (common_sources tbuf.m palloc.m util.m
    salloc.m pickle.m coro.m stat.m log_io.m cpu_feature.m crc32.c
    log_io_remote.m iproto.m exception.m errcode.c errinj.m latch.m)

if (ENABLE_TRACE)
  set (common_sources ${common_sources} trace.m)
endif()

add_library(core STATIC ${common_sources})
add_dependencies(core generate_headers luajit)
set_target_properties(core PROPERTIES COMPILE_FLAGS "${core_cflags}")

set (common_libraries cfg core ev coro gopt misc objc)

set (THREAD_LIB pthread)
if (ENABLE_STATIC)
    set (THREAD_LIB -Wl,--whole-archive pthread -Wl,--no-whole-archive)
endif()

set (common_libraries ${common_libraries} ${LUAJIT_LIB} ${THREAD_LIB})

if (TARGET_OS_LINUX)
  set (common_libraries ${common_libraries} dl)
endif()

if (TARGET_OS_DEBIAN_FREEBSD)
  set (common_libraries ${common_libraries} dl)
endif()

if (ENABLE_GCOV)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCOV_C_FLAGS}")
  set (LDFLAGS "${LDFLAGS} ${GCOV_LDFLAGS}")
  set (common_libraries ${common_libraries} gcov)
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
  set (common_libraries ${common_libraries} bfd)
  if (ENABLE_STATIC)
     include (FindZLIB)
     set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES} iberty)
  endif()
endif()

set (common_libraries ${common_libraries} PARENT_SCOPE)

=== test/CMakeLists.txt ===
add_custom_target(test
    COMMAND ${PROJECT_SOURCE_DIR}/test/run.sh --builddir=${PROJECT_BINARY_DIR} --vardir=${PROJECT_BINARY_DIR}/test/var)

add_custom_target(test-force
    COMMAND ${PROJECT_SOURCE_DIR}/test/run.sh --builddir=${PROJECT_BINARY_DIR} --force --vardir=${PROJECT_BINARY_DIR}/test/var)

add_subdirectory(box)
add_subdirectory(connector_c)

if ("${CPACK_GENERATOR}" STREQUAL "RPM")
    install (FILES ${CMAKE_SOURCE_DIR}/test/share/tarantool_rpm.cfg
             DESTINATION etc
             RENAME "tarantool.cfg")
    install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
             DESTINATION share/tarantool)
else()
    if (NOT CPACK_GENERATOR OR "${CPACK_GENERATOR}" STREQUAL "TGZ")
        install (FILES ${CMAKE_SOURCE_DIR}/test/share/tarantool_tgz.cfg
                 DESTINATION "${CMAKE_SYSCONF_DIR}"
                 RENAME "tarantool.cfg")
    else()
        install (FILES ${CMAKE_SOURCE_DIR}/test/share/tarantool.cfg
                 DESTINATION "${CMAKE_SYSCONF_DIR}")
    endif()

    install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
             DESTINATION "${CMAKE_LOCALSTATE_DIR}/lib/tarantool")
endif()

=== third_party/CMakeLists.txt ===

if (NOT HAVE_MEMMEM)
    set (misc_opt_sources ${misc_opt_sources} memmem.c)
endif()

if (NOT HAVE_MEMRCHR)
    set (misc_opt_sources ${misc_opt_sources} memrchr.c)
endif()

add_library (misc STATIC crc32.c proctitle.c qsort_arg.c ${misc_opt_sources})
if (NOT TARGET_OS_DEBIAN_FREEBSD) 
	if (TARGET_OS_FREEBSD)
	  set_source_files_properties(proctitle.c PROPERTIES
	       COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
	endif()
endif()

add_subdirectory(coro)
add_subdirectory(gopt)

macro (luajit_build)
    set (luajit_buildoptions BUILDMODE=static)
    if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
        set (luajit_buildoptions ${luajit_buildoptions} CCOPT=-O0)
        set (luajit_buildoptions ${luajit_buildoptions} CCDEBUG=-ggdb)
        set (luajit_buildoptions ${luajit_buildoptions} XCFLAGS='-DLUA_USE_APICHECK -DLUA_USE_ASSERT')
    endif()
    set (luajit_buildoptions ${luajit_buildoptions} Q='')
    if (${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
        add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/third_party/luajit
            COMMAND $(MAKE) clean
            COMMAND $(MAKE) -C src -t buildvm_x86.h buildvm_arm.h
                            buildvm_x64.h buildvm_x64win.h buildvm_ppc.h
                            buildvm_ppcspe.h
            COMMAND $(MAKE) -C src ${luajit_buildoptions}
            DEPENDS ${CMAKE_SOURCE_DIR}/CMakeCache.txt
        )
    else()
        add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit
            COMMAND mkdir ${PROJECT_BINARY_DIR}/third_party/luajit
        )
        add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/third_party/luajit
            COMMAND cp -r ${PROJECT_SOURCE_DIR}/third_party/luajit/* .
            COMMAND $(MAKE) clean
            COMMAND $(MAKE) -C src -t buildvm_x86.h buildvm_arm.h
                            buildvm_x64.h buildvm_x64win.h buildvm_ppc.h
                            buildvm_ppcspe.h
            COMMAND $(MAKE) -C src ${luajit_buildoptions}
            DEPENDS ${PROJECT_BINARY_DIR}/CMakeCache.txt ${PROJECT_BINARY_DIR}/third_party/luajit
        )
    endif()
    add_custom_target(libluajit
        DEPENDS ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
    )
    unset (luajit_buildoptions)
endmacro()

#
# building shipped luajit only if there is no
# usable system one (see cmake/luajit.cmake) or by demand.
#
if (ENABLE_BUNDLED_LUAJIT)
    luajit_build()
endif()

=== client/tarantool/CMakeLists.txt ===

project(tnt_cli)
include(FindCurses)

# checking for readline library
#
find_library(READLINE_LIB NAMES "readline")
find_library(READLINE_HISTORY_LIB NAMES "history")

if (NOT READLINE_LIB OR NOT READLINE_HISTORY_LIB)
    message(FATAL_ERROR "readline library not found.")
endif()

set (cli_deps ${READLINE_LIB} ${READLINE_HISTORY_LIB})

if (CURSES_FOUND)
    set(cli_deps ${cli_deps} ${CURSES_LIBRARIES})
else()
    message(FATAL_ERROR "curses library not found.")
endif()
find_library(TERMCAP_LIBRARY NAMES "termcap")
if (TERMCAP_LIBRARY)
    set(cli_deps ${cli_deps} ${TERMCAP_LIBRARY})
else()
    message(FATAL_ERROR "termcap library not found.")
endif()
# trying to resolve readline dependencies
#

set (cli "tarantool")
set (cli_sources tnt.c tnt_admin.c)
set (cli_libs tntnet tntsql tnt gopt ${cli_deps})

add_executable(${cli} ${cli_sources} ${CMAKE_SOURCE_DIR}/src/errcode.c)
set_target_properties(${cli} PROPERTIES COMPILE_FLAGS "${core_cflags}")
target_link_libraries (${cli} ${cli_libs})

install (TARGETS ${cli} DESTINATION bin)

=== connector/c/CMakeLists.txt ===

#
# library soname version
#
set(LIBTNT_VERSION_MAJOR "1")
set(LIBTNT_VERSION_MINOR "1")

set(LIBTNT_VERSION   "${LIBTNT_VERSION_MAJOR}.${LIBTNT_VERSION_MINOR}")
set(LIBTNT_SOVERSION "${LIBTNT_VERSION_MAJOR}")

add_subdirectory(tnt)
add_subdirectory(tntsql)
add_subdirectory(tntnet)
add_subdirectory(include)

=== doc/user/CMakeLists.txt ===

if (XMLLINT STREQUAL "XMLLINT-NOTFOUND")
    message (FATAL_ERROR "xmllint is missing")
endif()

if (XSLTPROC STREQUAL "XSLTPROC-NOTFOUND")
    message (FATAL_ERROR "xsltproc is missing")
endif()

if (LYNX STREQUAL "LYNX-NOTFOUND")
    message (FATAL_ERROR "lynx is missing")
endif()

set(PATH_USERGUIDE_HTML "${PROJECT_BINARY_DIR}/doc/www-data/tarantool_user_guide.html")
set(PATH_USERGUIDE_TXT "${PROJECT_BINARY_DIR}/doc/user/tarantool_user_guide.txt")

# XMLLINT is not able to validate SCHEMATRON constraints, and
# therefore is not a good validation tool for DocBook 5.  However,
# it can validate the entire document, following xinclude
# directives, and thus is used here. To validate individual XML
# files, or for troubleshooting, I (Kostja) recommend using jing,
# since its diagnostics output is significantly more readable:
# jing http://docbook.org/xml/5.0/rng/docbookxi.rng file.xml
#
add_custom_target(doc-check ALL
    COMMAND ${XMLLINT} --xinclude --noout --relaxng http://docbook.org/xml/5.0/rng/docbookxi.rng
            ${CMAKE_SOURCE_DIR}/doc/user/user.xml)

#
# xsltproc-based documentation generation (default)
#
add_custom_command(OUTPUT ${PATH_USERGUIDE_HTML}
    COMMAND ${XSLTPROC} --nonet
        --stringparam collect.xref.targets "all"
        --xinclude -o ${PATH_USERGUIDE_HTML}
        ${CMAKE_SOURCE_DIR}/doc/user/tnt-html.xsl
        ${CMAKE_SOURCE_DIR}/doc/user/user.xml)

add_custom_command(OUTPUT ${PATH_USERGUIDE_TXT}
    DEPENDS ${PATH_USERGUIDE_HTML}
    COMMAND ${LYNX} -dump ${PATH_USERGUIDE_HTML} > ${PATH_USERGUIDE_TXT})

add_custom_target(html DEPENDS ${PATH_USERGUIDE_HTML})
add_custom_target(txt  DEPENDS ${PATH_USERGUIDE_TXT})

add_custom_target(doc-autogen ALL
    DEPENDS ${PATH_USERGUIDE_HTML} ${PATH_USERGUIDE_TXT})

if ("${CPACK_GENERATOR}" STREQUAL "RPM")
    install (FILES ${PATH_USERGUIDE_HTML}
                   ${PATH_USERGUIDE_TXT} DESTINATION /usr/local/doc/tarantool)
else()
    install (FILES ${PATH_USERGUIDE_HTML}
                   ${PATH_USERGUIDE_TXT} DESTINATION share/doc/tarantool)
endif()

add_custom_target(pdf
    COMMAND ${XSLTPROC} --nonet
        --stringparam collect.xref.targets "all"
        --xinclude -o tarantool_user_guide.fo
        ${CMAKE_SOURCE_DIR}/doc/user/tnt-fo.xsl
        ${CMAKE_SOURCE_DIR}/doc/user/user.xml
    COMMAND fop tarantool_user_guide.fo tarantool_user_guide.pdf)

add_custom_target(relink
    COMMAND ${XSLTPROC} --nonet
        --stringparam collect.xref.targets "only"
        --xinclude -o ${PATH_USERGUIDE_HTML}
        ${CMAKE_SOURCE_DIR}/doc/user/tnt-html.xsl
        ${CMAKE_SOURCE_DIR}/doc/user/user.xml)

#
# Java saxon-based documentation generation (misc)
#
add_custom_target(html-saxon
    COMMAND java -cp "/usr/share/java/saxon.jar:/usr/share/java/xml-resolver.jar:/usr/share/java/docbook-xsl-saxon.jar:/usr/share/java/xercesImpl.jar:/etc/xml/resolver:/usr/share/java/xslthl.jar:/usr/share/java/xml-commons-resolver-1.1.jar"
        -Djavax.xml.parsers.DocumentBuilderFactory=org.apache.xerces.jaxp.DocumentBuilderFactoryImpl
        -Djavax.xml.parsers.SAXParserFactory=org.apache.xerces.jaxp.SAXParserFactoryImpl
        -Dorg.apache.xerces.xni.parser.XMLParserConfiguration=org.apache.xerces.parsers.XIncludeParserConfiguration
        com.icl.saxon.StyleSheet
        -x org.apache.xml.resolver.tools.ResolvingXMLReader
        -y org.apache.xml.resolver.tools.ResolvingXMLReader
        -r org.apache.xml.resolver.tools.CatalogResolver
        -u -o ${PATH_USERGUIDE_HTML} user.xml tnt-html.xsl)

add_custom_target(pdf-saxon
    COMMAND java -cp "/usr/share/java/saxon.jar:/usr/share/java/xml-commons-resolver-1.1.jar:/usr/share/java/docbook-xsl-saxon.jar:/usr/share/java/xercesImpl.jar:/etc/xml/resolver:/usr/share/java/xslthl.jar"
        -Djavax.xml.parsers.DocumentBuilderFactory=org.apache.xerces.jaxp.DocumentBuilderFactoryImpl
        -Djavax.xml.parsers.SAXParserFactory=org.apache.xerces.jaxp.SAXParserFactoryImpl
        -Dorg.apache.xerces.xni.parser.XMLParserConfiguration=org.apache.xerces.parsers.XIncludeParserConfiguration
        com.icl.saxon.StyleSheet
        -x org.apache.xml.resolver.tools.ResolvingXMLReader
        -y org.apache.xml.resolver.tools.ResolvingXMLReader
        -r org.apache.xml.resolver.tools.CatalogResolver
        -u -o tarantool_user_guide.fo user.xml tnt-fo.xsl
    COMMAND fop tarantool_user_guide.fo tarantool_user_guide.pdf)

=== mod/box/CMakeLists.txt ===
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 mod/box/memcached-grammar.rl
                     -o mod/box/memcached-grammar.m
    DEPENDS ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.rl)
# Do not clean memcached-grammar.m in 'make clean'.
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM true)
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES tmp.c box.lua.c)

add_custom_target(generate_memcached_grammar_m DEPENDS
    ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m)

# Do not try to randomly re-generate memcached-grammar.m
# after a fresh checkout/branch switch.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m)

ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_BINARY_DIR}/mod/box/box.lua.c
    COMMAND ${ECHO} 'const char box_lua[] =' > tmp.c
    COMMAND ${CMAKE_BINARY_DIR}/extra/txt2c
        ${CMAKE_SOURCE_DIR}/mod/box/box.lua >> tmp.c
    COMMAND ${ECHO} '\;' >> tmp.c
    COMMAND ${CMAKE_COMMAND} -E copy_if_different tmp.c
        ${CMAKE_BINARY_DIR}/mod/box/box.lua.c
    COMMAND ${CMAKE_COMMAND} -E remove tmp.c
    DEPENDS ${CMAKE_SOURCE_DIR}/mod/box/box.lua)

add_custom_target(generate_box_lua_c
    DEPENDS ${CMAKE_BINARY_DIR}/mod/box/box.lua.c)

set_source_files_properties(memcached-grammar.m
    PROPERTIES HEADER_FILE_ONLY true)

set_source_files_properties(memcached.m
    PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")

tarantool_module("box" tuple.m index.m tree.m box.m box.lua.c box_lua.m
    memcached.m memcached-grammar.m)

=== test/connector_c/CMakeLists.txt ===

tarantool_client("tt" tt.c)
tarantool_client("update" update.c)

=== debian/changelog ===
tarantool (1.4.5+20120503-2) unstable; urgency=low

  * Add librt to linklist (fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 04 May 2012 09:27:04 +0400

tarantool (1.4.5+20120503-1) unstable; urgency=low

  * New upstream snapshot.
  * Add Priority for sources.
  * Add libtarantool* packages that weren't be packaged earlier: upstream
    renamed them, now we have no conflicts with the other debian packages.
  * Add libncurses5-dev into Build-Depends.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 03 May 2012 17:35:18 +0400

=== debian/control ===
Source: tarantool
Priority: optional
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 gobjc,
 cmake,
 libreadline-dev,
 python-yaml,
 python-daemon,
 python-pexpect,
 libncurses5-dev
Section: database
Standards-Version: 3.9.2
Homepage: http://tarantool.org/
VCS-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tarantool.git;a=summary
VCS-Git: git+ssh://git.debian.org/git/collab-maint/tarantool.git

Package: tarantool-common
Architecture: all
Priority: optional
Depends: ${misc:Depends}, adduser
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides configs and logs infrastructure for tarantool.

Package: tarantool
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-common
Suggests: libmr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides tarantool server.

Package: tarantool-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for tarantool.

Package: tarantool-client
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libmr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool.

Package: tarantool-client-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool-client (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool (debug symbols).

Package: libtarantool1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool.

Package: libtarantool1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantool1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantool1.

Package: libtarantool-dev
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
 libtarantool1 (= ${binary:Version}),
 libtarantoolsql1 (= ${binary:Version}),
 libtarantoolnet1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides headers for libtarantool* libraries.

Package: libtarantoolnet1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool (network).

Package: libtarantoolnet1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolnet1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolnet1.

Package: libtarantoolsql1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides SQL-parser for tarantool.

Package: libtarantoolsql1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolsql1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolsql1.

=== debian/rules ===
#!/usr/bin/make -f

VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')

DEB_CMAKE_EXTRA_FLAGS := \
	-DCMAKE_BUILD_TYPE=RelWithDebugInfo \
	-DENABLE_CLIENT=true

DEB_DH_INSTALLINIT_ARGS := --name=tarantool

DEB_CMAKE_INSTALL_PREFIX := /usr
DEB_CMAKE_NORMAL_ARGS := -DCMAKE_INSTALL_PREFIX="$(DEB_CMAKE_INSTALL_PREFIX)" \
    -DCMAKE_C_FLAGS="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
    -DCMAKE_SKIP_RPATH=ON \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_SYSCONF_DIR=/etc/tarantool \
    -DCMAKE_LOCALSTATE_DIR=/var
#     -DENABLE_STATIC=ON
#    -DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
#    -DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \


include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_BUILDDIR := build-area

tarball: clean
	cd .. && tar --exclude=.git --exclude=debian \
		-czf tarantool_$(UVERSION).orig.tar.gz tarantool-$(UVERSION)

clean::
	find -type f -name \*.pyc -delete
#	find test -name \*.reject -delete

install/tarantool-dbg::
	rm -fr debian/tarantool-dbg/usr/share/doc/tarantool-dbg

install/tarantool::
#         make -C build-area test-force || /bin/true


install/tarantool-common::
	pod2man -c 'tarantool instances control' \
	    debian/tarantool_instance.pod > build-area/tarantool_instance.1
	pod2man -c 'tarantool log rotation' \
	    debian/scripts/tarantool_logrotate \
	    	 > build-area/tarantool_logrotate.1
	install -m0755 extra/logger.pl \
	    debian/tarantool-common/usr/lib/tarantool/logger

## tarantool 1.4.5+20120522

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,10 +45,10 @@
 
 execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                 OUTPUT_VARIABLE GCC_VERSION)
-if (GCC_VERSION VERSION_GREATER 4.4 OR GCC_VERSION VERSION_EQUAL 4.4)
-        message(STATUS "GCC Version >= 4.4")
-else()
-    message (FATAL_ERROR "GCC version should be >= 4.4")
+if (GCC_VERSION VERSION_GREATER 4.1 OR GCC_VERSION VERSION_EQUAL 4.1)
+        message(STATUS "GCC Version >= 4.1")
+else()
+    message (FATAL_ERROR "GCC version should be >= 4.1")
 endif()
 
 #
@@ -83,6 +83,8 @@
 check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
 check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
 check_include_file(sys/time.h HAVE_SYS_TIME_H)
+check_include_file(unwind.h HAVE_UNWIND_H)
+check_include_file(cpuid.h HAVE_CPUID_H)
 
 check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
 check_function_exists(fdatasync HAVE_FDATASYNC)
@@ -152,7 +154,7 @@
 #
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "4")
-set (CPACK_PACKAGE_VERSION_PATCH "5")
+set (CPACK_PACKAGE_VERSION_PATCH "6")
 if (TARANTOOL_VERSION STREQUAL "")
     set (TARANTOOL_VERSION
         "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,6 @@
 add_library(ev tarantool_ev.c)
 
 check_c_compiler_flag ("-Wno-unused-result" gcc_has_wno_unused_result)
-check_c_compiler_flag ("-msse4" gcc_has_sse4)
-check_include_file("cpuid.h" gcc_has_cpuid)
-
-if (NOT gcc_has_sse4)
-    message (FATAL_ERROR "GCC must support SSE4 instructions (-msse4).")
-endif()
-
-if (NOT gcc_has_cpuid)
-    message (FATAL_ERROR "GCC is missing cpuid.h")
-endif()
 
 if (gcc_has_wno_unused_result)
     set_source_files_properties(tarantool_ev.c
@@ -32,7 +22,7 @@
 #
 # libev uses ceil and floor from the standard math library
 #
-target_link_libraries(ev m)
+target_link_libraries(ev m rt)
 
 #
 # Build admin.m from admin.rl, but only if admin.rl was changed.
@@ -57,9 +47,6 @@
 # revision control.
 #
 set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)
-
-set_source_files_properties(cpu_feature.m
-    PROPERTIES COMPILE_FLAGS "-msse3 -msse4")
 
 #
 # Used by modules.
@@ -109,10 +96,10 @@
 endif()
 
 if (ENABLE_BACKTRACE AND HAVE_BFD)
-  set (common_libraries ${common_libraries} bfd)
+  set (common_libraries ${common_libraries} bfd iberty)
   if (ENABLE_STATIC)
      include (FindZLIB)
-     set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES} iberty)
+     set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES})
   endif()
 endif()

=== third_party/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,10 @@
 
 add_library (misc STATIC crc32.c proctitle.c qsort_arg.c ${misc_opt_sources})
 if (NOT TARGET_OS_DEBIAN_FREEBSD) 
-	if (TARGET_OS_FREEBSD)
-	  set_source_files_properties(proctitle.c PROPERTIES
-	       COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
-	endif()
+    if (TARGET_OS_FREEBSD)
+      set_source_files_properties(proctitle.c PROPERTIES
+           COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
+    endif()
 endif()
 
 add_subdirectory(coro)
@@ -20,11 +20,18 @@
 
 macro (luajit_build)
     set (luajit_buildoptions BUILDMODE=static)
+    set (luajit_copt ${CCOPT})
     if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
-        set (luajit_buildoptions ${luajit_buildoptions} CCOPT=-O0)
         set (luajit_buildoptions ${luajit_buildoptions} CCDEBUG=-ggdb)
+        set (luajit_copt ${luajit_copt} -O1)
         set (luajit_buildoptions ${luajit_buildoptions} XCFLAGS='-DLUA_USE_APICHECK -DLUA_USE_ASSERT')
+    else ()
+        set (luajit_copt ${luajit_copt} -O2)
     endif()
+    if (NOT HAVE_UNWIND_H)
+        set (luajit_copt ${luajit_copt} -I${PROJECT_SOURCE_DIR}/third_party/compat)
+    endif()
+    set (luajit_buildoptions ${luajit_buildoptions} CCOPT="${luajit_copt}")
     set (luajit_buildoptions ${luajit_buildoptions} Q='')
     if (${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
         add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a

=== mod/box/CMakeLists.txt ===
--- 
+++ 
@@ -34,5 +34,5 @@
 set_source_files_properties(memcached.m
     PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")
 
-tarantool_module("box" tuple.m index.m tree.m box.m box.lua.c box_lua.m
-    memcached.m memcached-grammar.m)
+tarantool_module("box" tuple.m index.m tree.m space.m port.m request.m
+    txn.m box.m box.lua.c box_lua.m memcached.m memcached-grammar.m)

=== debian/changelog ===
tarantool (1.4.5+20120522-1) unstable; urgency=low

  * New git snapshot: upstream upgraded libtarantool.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 22 May 2012 22:55:07 +0400

tarantool (1.4.5+20120510-1) unstable; urgency=low

  * New git snapshot (it provides script_dir option).
  * Add binutils-dev to B-D list (for debugging crashes, #672327).

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 10 May 2012 10:23:28 +0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
  python-yaml,
  python-daemon,
  python-pexpect,
- libncurses5-dev
+ libncurses5-dev,
+ binutils-dev
 Section: database
 Standards-Version: 3.9.2
 Homepage: http://tarantool.org/
@@ -37,7 +38,7 @@
 Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
 Priority: optional
 Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-common
-Suggests: libmr-tarantool-perl
+Suggests: libmr-tarantool-perl, libdr-tarantool-perl
 Description: high performance key/value storage server
  Tarantool is an open-source NoSQL database, developed by Mail.ru.
  Its key properties include:

## tarantool 1.4.6+20120524

=== debian/changelog ===
tarantool (1.4.6+20120524-1) unstable; urgency=low

  * Fix version number.
  * Fix tarantool_instance: user could not to define 'file_descriptors'

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 24 May 2012 12:57:27 +0400
